/* A Bison parser, made from spice.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	TITLE	257
# define	COMMENT	258
# define	CAPACITOR	259
# define	DIODE	260
# define	ISOURCE	261
# define	JFET	262
# define	INDUCTOR	263
# define	MOSFET	264
# define	BJT	265
# define	COUPLING	266
# define	RESISTOR	267
# define	VSOURCE	268
# define	SUBCKTINST	269
# define	SUBCKT	270
# define	ALTER	271
# define	CONTROL	272
# define	DATA	273
# define	DCVOLT	274
# define	DELLIB	275
# define	END	276
# define	ENDDATA	277
# define	ENDL	278
# define	ENDS	279
# define	GLOBAL	280
# define	ICVOLT	281
# define	LIB	282
# define	MODEL	283
# define	NODESET	284
# define	OPTIONS	285
# define	PARAM	286
# define	PC	287
# define	PROTECT	288
# define	SYSTEM	289
# define	UNPROTECT	290
# define	WIDTH	291
# define	ACSWEEP	292
# define	DCSWEEP	293
# define	FOURIER	294
# define	NET	295
# define	DISTORTION	296
# define	NOISE	297
# define	OPPOINT	298
# define	POLEZERO	299
# define	SAMPLE	300
# define	SENS	301
# define	TEMP	302
# define	TRANSFER	303
# define	TRAN	304
# define	MEASURE	305
# define	GRAPH	306
# define	PLOT	307
# define	PRINT	308
# define	ARGIDENT	309
# define	ARGINT	310
# define	ARGDECIMAL	311
# define	ARGFLOAT	312
# define	ARGUNIT	313
# define	ARGSEND	314
# define	OPENQUOTE	315
# define	CLOSEQUOTE	316
# define	QUOTESTRING	317


/* -----------------------------------------------------------------------------
* COPYRIGHT  (c)  1997 
* THE REGENTS OF THE UNIVERSITY OF MICHIGAN
* ALL RIGHTS RESERVED
* 
* PERMISSION IS GRANTED TO USE, COPY, CREATE DERIVATIVE WORKS 
* AND REDISTRIBUTE THIS SOFTWARE AND SUCH DERIVATIVE WORKS FOR 
* ANY PURPOSE, SO LONG AS NO FEE IS CHARGED, AND SO LONG AS 
* THE COPYRIGHT NOTICE ABOVE, THIS GRANT OF PERMISSION, AND 
* THE DISCLAIMER BELOW APPEAR IN ALL COPIES MADE; AND SO LONG 
* AS THE NAME OF THE UNIVERSITY OF MICHIGAN IS NOT USED IN ANY 
* ADVERTISING OR PUBLICITY PERTAINING TO THE USE OR 
* DISTRIBUTION OF THIS SOFTWARE WITHOUT SPECIFIC, WRITTEN 
* PRIOR AUTHORIZATION.
* 
* THIS SOFTWARE IS PROVIDED AS IS, WITHOUT REPRESENTATION 
* FROM THE UNIVERSITY OF MICHIGAN AS TO ITS FITNESS 
* FOR ANY PURPOSE, AND WITHOUT WARRANTY BY THE 
* UNIVERSITY OF MICHIGAN OF ANY KIND, EITHER EXPRESS OR 
* IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES 
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE 
* REGENTS OF THE UNIVERSITY OF MICHIGAN SHALL NOT BE LIABLE 
* FOR ANY DAMAGES, INCLUDING SPECIAL, INDIRECT, INCIDENTAL, OR 
* CONSEQUENTIAL DAMAGES, WITH RESPECT TO ANY CLAIM ARISING OUT 
* HAS BEEN OR IS HEREAFTER ADVISED OF THE POSSIBILITY OF SUCH 
* DAMAGES.
----------------------------------------------------------------------------- */

/**************************************************************************************
 * File: spice.y
 *
 * Purpose: parser for spicedeck, intended to gnu bison.
 *
 * Author: Michael A Riepe
 *	   Stephen T. Frezza (STF)
 *
 * RCS Version:
 *     $Id: spice.y,v 1.1.1.1 2002/05/01 14:23:27 mguthaus Exp $
 **************************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <strings.h>
#include <stream.h>
#ifdef HAVE_STL
   #include <stl>		// Modified to support g++-3 instalations
#else
   #include <stl.h>
#endif
#include "defs.hh"
#include "utils.hh"
#include "macros.hh"
#include "argument.hh"
#include "circuit.hh"
#include "hspice_parser.hh"
    
// externs
extern FILE *yyin;

// forward declarations
double adjust_number (double arg, char *unit);
void yyerror(char *s);
int yywrap();
extern int yylex();
extern int yy_flex_debug; 

// global variables
static unsigned currentFile;
static vector<char*> *fileList;
static unsigned nFiles;
static circuit *yyCircuit;


#ifndef YYSTYPE
typedef union {
    int dval;
    double rval;
    char *sval;
    char cval;
    Argument *aval;
    ArgumentVec *av_val;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 1
#endif



#define	YYFINAL		252
#define	YYFLAG		-32768
#define	YYNTBASE	73

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 317 ? yytranslate[x] : 145)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      68,    69,     5,     3,    70,     4,     2,     6,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    71,     2,
       2,    72,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     5,     7,     9,    11,    13,    15,    17,
      19,    21,    23,    25,    27,    29,    31,    33,    35,    37,
      39,    41,    43,    45,    47,    49,    51,    53,    55,    57,
      59,    61,    63,    65,    67,    69,    71,    73,    75,    77,
      79,    81,    83,    85,    87,    89,    91,    93,    95,    97,
      99,   101,   103,   105,   107,   109,   111,   113,   115,   117,
     119,   123,   127,   131,   135,   139,   143,   147,   151,   155,
     159,   163,   167,   169,   173,   177,   181,   185,   189,   192,
     196,   200,   204,   208,   212,   217,   223,   231,   235,   239,
     243,   247,   249,   253,   255,   259,   263,   267,   271,   275,
     279,   283,   286,   290,   294,   298,   302,   306,   310,   314,
     318,   322,   326,   330,   332,   334,   336,   339,   341,   344,
     348,   350,   353,   355,   357,   359,   362,   364,   367,   370,
     372,   374,   376,   378,   380,   382,   387,   391,   395,   399,
     401,   405,   407,   408
};
static const short yyrhs[] =
{
      74,     0,    73,    74,     0,    75,     0,    76,     0,    77,
       0,    78,     0,    79,     0,    80,     0,    81,     0,    82,
       0,    83,     0,    84,     0,    86,     0,    87,     0,    88,
       0,    89,     0,    90,     0,    91,     0,    85,     0,    92,
       0,    93,     0,    94,     0,    95,     0,    96,     0,    97,
       0,    98,     0,    99,     0,   100,     0,   101,     0,   102,
       0,   103,     0,   104,     0,   105,     0,   106,     0,   107,
       0,   108,     0,   109,     0,   110,     0,   111,     0,   112,
       0,   113,     0,   114,     0,   115,     0,   116,     0,   117,
       0,   118,     0,   119,     0,   120,     0,   121,     0,   122,
       0,   123,     0,   124,     0,   125,     0,   126,     0,   127,
       0,   128,     0,   129,     0,   130,     0,   131,     0,    15,
     132,    64,     0,     9,   132,    64,     0,    10,   132,    64,
       0,    13,   132,    64,     0,    16,   132,    64,     0,    11,
     132,    64,     0,    12,   132,    64,     0,    14,   132,    64,
       0,    17,   132,    64,     0,    19,   132,    64,     0,    18,
     132,    64,     0,    20,   132,    64,     0,    21,     0,    22,
     132,    64,     0,    23,   132,    27,     0,    24,   132,    64,
       0,    25,   132,    64,     0,    26,   132,    64,     0,    26,
      64,     0,    28,   132,    64,     0,    29,   144,    64,     0,
      30,   132,    64,     0,    31,   132,    64,     0,    32,   132,
      64,     0,    33,   136,   136,    64,     0,    33,   136,   136,
     134,    64,     0,    33,   136,   136,    68,   134,    69,    64,
       0,    34,   132,    64,     0,    35,   132,    64,     0,    36,
     132,    64,     0,    37,   132,    64,     0,    38,     0,    39,
     132,    64,     0,    40,     0,    41,   132,    64,     0,    42,
     132,    64,     0,    43,   132,    64,     0,    44,   132,    64,
       0,    45,   132,    64,     0,    46,   132,    64,     0,    47,
     132,    64,     0,    48,    64,     0,    48,   132,    64,     0,
      49,   132,    64,     0,    50,   132,    64,     0,    51,   132,
      64,     0,    52,   132,    64,     0,    53,   132,    64,     0,
      54,   132,    64,     0,    55,   132,    64,     0,    56,   132,
      64,     0,    57,   132,    64,     0,    58,   132,    64,     0,
       7,     0,     8,     0,   135,     0,   132,   135,     0,   136,
       0,   133,   136,     0,   133,    70,   136,     0,   139,     0,
     134,   139,     0,   136,     0,   137,     0,    59,     0,    60,
      63,     0,    60,     0,    60,    71,     0,    61,    63,     0,
      61,     0,    62,     0,   141,     0,   138,     0,   139,     0,
     140,     0,    59,    68,   133,    69,     0,    59,    72,   142,
       0,   138,    72,   142,     0,    65,    67,    66,     0,   143,
       0,   142,    70,   143,     0,   136,     0,     0,    59,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   114,   115,   118,   119,   120,   121,   122,   123,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     139,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   179,   180,   181,   182,   185,   186,
     193,   207,   221,   235,   249,   263,   277,   291,   305,   319,
     333,   352,   370,   376,   389,   402,   415,   428,   440,   446,
     459,   468,   481,   494,   507,   517,   532,   550,   563,   576,
     589,   602,   608,   621,   627,   645,   658,   671,   684,   697,
     710,   723,   729,   742,   755,   768,   781,   794,   807,   825,
     838,   851,   864,   882,   892,   907,   914,   921,   928,   933,
     940,   947,   954,   959,   966,   971,   980,   987,   994,  1003,
    1010,  1017,  1024,  1029,  1034,  1041,  1048,  1055,  1062,  1069,
    1076,  1083,  1086,  1092
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "'+'", "'-'", "'*'", "'/'", "TITLE", 
  "COMMENT", "CAPACITOR", "DIODE", "ISOURCE", "JFET", "INDUCTOR", 
  "MOSFET", "BJT", "COUPLING", "RESISTOR", "VSOURCE", "SUBCKTINST", 
  "SUBCKT", "ALTER", "CONTROL", "DATA", "DCVOLT", "DELLIB", "END", 
  "ENDDATA", "ENDL", "ENDS", "GLOBAL", "ICVOLT", "LIB", "MODEL", 
  "NODESET", "OPTIONS", "PARAM", "PC", "PROTECT", "SYSTEM", "UNPROTECT", 
  "WIDTH", "ACSWEEP", "DCSWEEP", "FOURIER", "NET", "DISTORTION", "NOISE", 
  "OPPOINT", "POLEZERO", "SAMPLE", "SENS", "TEMP", "TRANSFER", "TRAN", 
  "MEASURE", "GRAPH", "PLOT", "PRINT", "ARGIDENT", "ARGINT", "ARGDECIMAL", 
  "ARGFLOAT", "ARGUNIT", "ARGSEND", "OPENQUOTE", "CLOSEQUOTE", 
  "QUOTESTRING", "'('", "')'", "','", "':'", "'='", "statement_list", 
  "statement", "device", "subcircuit", "control_card", "analysis_card", 
  "output_card", "other", "bjt", "capacitor", "diode", "inductor", 
  "coupling", "isource", "jfet", "mosfet", "resistor", "subcktinst", 
  "vsource", "subckt", "alter", "control", "data", "dcvolt", "dellib", 
  "end", "endl", "ends", "global", "icvolt", "lib", "model", "nodeset", 
  "options", "param", "pc", "protect", "system", "unprotect", "width", 
  "acsweep", "dcsweep", "fourier", "net", "distortion", "noise", 
  "oppoint", "polezero", "sample", "sens", "temp", "transfer", "tran", 
  "measure", "graph", "plot", "print", "title", "comment", 
  "argument_list", "simple_argument_list", "parameter_list", "argument", 
  "simple_arg", "complex_arg", "function", "parameter", "node_assignment", 
  "quoted_string", "param_list", "param_val", "ends_arg", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    73,    73,    74,    74,    74,    74,    74,    74,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      76,    77,    77,    77,    77,    77,    77,    77,    77,    77,
      77,    77,    77,    77,    77,    77,    77,    77,    77,    77,
      77,    78,    78,    78,    78,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    79,    79,    79,    79,    80,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    98,    99,
     100,   101,   102,   103,   104,   104,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   132,   133,   133,   133,
     134,   134,   135,   135,   136,   136,   136,   136,   136,   136,
     136,   136,   137,   137,   137,   138,   139,   140,   141,   142,
     142,   143,   144,   144
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     3,     3,     3,     3,     3,     2,     3,
       3,     3,     3,     3,     4,     5,     7,     3,     3,     3,
       3,     1,     3,     1,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     2,     1,     2,     3,
       1,     2,     1,     1,     1,     2,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     4,     3,     3,     3,     1,
       3,     1,     0,     1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,   113,   114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    72,     0,     0,     0,     0,
       0,     0,   142,     0,     0,     0,     0,     0,     0,     0,
       0,    91,     0,    93,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    19,    13,    14,    15,    16,    17,
      18,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,   124,   126,   129,   130,     0,     0,   115,   122,   123,
     132,   133,   134,   131,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
       0,     0,   143,     0,     0,     0,     0,   124,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   101,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,     0,     0,   125,   127,   128,     0,
      61,   116,     0,    62,    65,    66,    63,    67,    60,    64,
      68,    70,    69,    71,    73,    74,    75,    76,    77,    79,
      80,    81,    82,    83,     0,    87,    88,    89,    90,    92,
      94,    95,    96,    97,    98,    99,   100,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,     0,   117,
     141,   136,   139,   138,   137,     0,    84,     0,     0,   120,
     135,     0,   118,     0,     0,    85,   121,   119,   140,     0,
      86,     0,     0
};

static const short yydefgoto[] =
{
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   116,
     228,   238,   117,   118,   119,   120,   121,   122,   123,   231,
     232,   143
};

static const short yypact[] =
{
     211,-32768,-32768,   151,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,-32768,   151,   151,   151,   151,
       2,   151,   -55,   151,   151,   151,   519,   151,   151,   151,
     151,-32768,   151,-32768,   151,   151,   151,   151,   151,   151,
     151,    98,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   151,     1,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,    53,    20,   -60,-32768,   -62,   105,-32768,-32768,-32768,
     -66,-32768,-32768,-32768,   112,   119,   126,   133,   144,   259,
     267,   274,   281,   288,   295,   302,    78,   309,   316,-32768,
     323,   330,-32768,   -36,   337,   344,   351,-32768,   519,   358,
     365,   372,   379,   386,   393,   400,   407,   414,   421,   428,
     435,-32768,   442,   449,   456,   463,   470,   477,   484,   491,
     498,   505,   512,-32768,   519,   519,-32768,-32768,-32768,    -1,
  -32768,-32768,   519,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,    64,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    85,-32768,
  -32768,    17,-32768,-32768,    17,    46,-32768,    33,   -57,-32768,
  -32768,   519,-32768,   519,    58,-32768,-32768,-32768,-32768,    60,
  -32768,   129,-32768
};

static const short yypgoto[] =
{
  -32768,    79,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   266,
  -32768,  -107,   -56,   -26,-32768,-32768,  -118,-32768,-32768,   -49,
    -109,-32768
};


#define	YYLAST		584


static const short yytable[] =
{
     148,   251,   235,   178,   142,   179,   182,   245,     1,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,   200,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
     181,   111,   112,   113,   114,   233,   139,   115,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   176,   181,   181,   239,   243,   181,   181,
     181,   177,   235,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   195,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   235,   175,   239,
     246,   174,   204,   235,   250,   175,   246,   249,   236,   252,
     244,   173,   237,   234,   248,     0,     0,   111,   112,   113,
     114,     0,     0,   115,   147,   112,   113,   114,   229,   230,
     115,     0,     0,     0,   240,   241,   230,   111,   112,   113,
     114,     0,   161,   115,   111,   112,   113,   114,     0,   180,
     115,   111,   112,   113,   114,     0,   183,   115,   111,   112,
     113,   114,     0,   184,   115,   111,   112,   113,   114,     0,
     185,   115,   111,   112,   113,   114,     0,   186,   115,     0,
       0,     0,   242,   111,   112,   113,   114,     0,   187,   115,
     111,   112,   113,   114,     0,   247,   115,   230,     1,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,     0,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,     0,   135,   136,   137,   138,   140,   141,     0,   144,
     145,   146,     0,   149,   150,   151,   152,     0,   153,     0,
     154,   155,   156,   157,   158,   159,   160,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   111,   112,
     113,   114,     0,   188,   115,     0,   111,   112,   113,   114,
       0,   189,   115,   111,   112,   113,   114,     0,   190,   115,
     111,   112,   113,   114,     0,   191,   115,   111,   112,   113,
     114,     0,   192,   115,   111,   112,   113,   114,     0,   193,
     115,   111,   112,   113,   114,     0,   194,   115,   111,   112,
     113,   114,     0,   196,   115,   111,   112,   113,   114,     0,
     197,   115,   111,   112,   113,   114,     0,   198,   115,   111,
     112,   113,   114,     0,   199,   115,   111,   112,   113,   114,
       0,   201,   115,   111,   112,   113,   114,     0,   202,   115,
     111,   112,   113,   114,     0,   203,   115,   111,   112,   113,
     114,     0,   205,   115,   111,   112,   113,   114,     0,   206,
     115,   111,   112,   113,   114,     0,   207,   115,   111,   112,
     113,   114,     0,   208,   115,   111,   112,   113,   114,     0,
     209,   115,   111,   112,   113,   114,     0,   210,   115,   111,
     112,   113,   114,     0,   211,   115,   111,   112,   113,   114,
       0,   212,   115,   111,   112,   113,   114,     0,   213,   115,
     111,   112,   113,   114,     0,   214,   115,   111,   112,   113,
     114,     0,   215,   115,   111,   112,   113,   114,     0,   216,
     115,   111,   112,   113,   114,     0,   217,   115,   111,   112,
     113,   114,     0,   218,   115,   111,   112,   113,   114,     0,
     219,   115,   111,   112,   113,   114,     0,   220,   115,   111,
     112,   113,   114,     0,   221,   115,   111,   112,   113,   114,
       0,   222,   115,   111,   112,   113,   114,     0,   223,   115,
     111,   112,   113,   114,     0,   224,   115,   111,   112,   113,
     114,     0,   225,   115,   111,   112,   113,   114,     0,   226,
     115,   111,   112,   113,   114,     0,   227,   115,   147,   112,
     113,   114,     0,     0,   115
};

static const short yycheck[] =
{
      26,     0,    59,    63,    59,    67,    72,    64,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    64,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
     116,    59,    60,    61,    62,    66,    64,    65,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    63,   140,   141,   204,    70,   144,   145,
     146,    71,    59,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    27,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    59,    72,   237,
     238,    68,   148,    59,    64,    72,   244,    69,    64,     0,
     237,    52,    68,   182,   243,    -1,    -1,    59,    60,    61,
      62,    -1,    -1,    65,    59,    60,    61,    62,   174,   175,
      65,    -1,    -1,    -1,    69,    70,   182,    59,    60,    61,
      62,    -1,    64,    65,    59,    60,    61,    62,    -1,    64,
      65,    59,    60,    61,    62,    -1,    64,    65,    59,    60,
      61,    62,    -1,    64,    65,    59,    60,    61,    62,    -1,
      64,    65,    59,    60,    61,    62,    -1,    64,    65,    -1,
      -1,    -1,   228,    59,    60,    61,    62,    -1,    64,    65,
      59,    60,    61,    62,    -1,   241,    65,   243,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    27,    28,    29,    30,    -1,    32,    -1,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    59,    60,
      61,    62,    -1,    64,    65,    -1,    59,    60,    61,    62,
      -1,    64,    65,    59,    60,    61,    62,    -1,    64,    65,
      59,    60,    61,    62,    -1,    64,    65,    59,    60,    61,
      62,    -1,    64,    65,    59,    60,    61,    62,    -1,    64,
      65,    59,    60,    61,    62,    -1,    64,    65,    59,    60,
      61,    62,    -1,    64,    65,    59,    60,    61,    62,    -1,
      64,    65,    59,    60,    61,    62,    -1,    64,    65,    59,
      60,    61,    62,    -1,    64,    65,    59,    60,    61,    62,
      -1,    64,    65,    59,    60,    61,    62,    -1,    64,    65,
      59,    60,    61,    62,    -1,    64,    65,    59,    60,    61,
      62,    -1,    64,    65,    59,    60,    61,    62,    -1,    64,
      65,    59,    60,    61,    62,    -1,    64,    65,    59,    60,
      61,    62,    -1,    64,    65,    59,    60,    61,    62,    -1,
      64,    65,    59,    60,    61,    62,    -1,    64,    65,    59,
      60,    61,    62,    -1,    64,    65,    59,    60,    61,    62,
      -1,    64,    65,    59,    60,    61,    62,    -1,    64,    65,
      59,    60,    61,    62,    -1,    64,    65,    59,    60,    61,
      62,    -1,    64,    65,    59,    60,    61,    62,    -1,    64,
      65,    59,    60,    61,    62,    -1,    64,    65,    59,    60,
      61,    62,    -1,    64,    65,    59,    60,    61,    62,    -1,
      64,    65,    59,    60,    61,    62,    -1,    64,    65,    59,
      60,    61,    62,    -1,    64,    65,    59,    60,    61,    62,
      -1,    64,    65,    59,    60,    61,    62,    -1,    64,    65,
      59,    60,    61,    62,    -1,    64,    65,    59,    60,    61,
      62,    -1,    64,    65,    59,    60,    61,    62,    -1,    64,
      65,    59,    60,    61,    62,    -1,    64,    65,    59,    60,
      61,    62,    -1,    -1,    65
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 60:
{
            yyCircuit->add_bjt(yyvsp[-2].sval,yyvsp[-1].av_val);
            DBG1(printf("seen BJT: %s ",yyvsp[-2].sval);
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            free(yyvsp[-2].sval);
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 61:
{
            yyCircuit->add_capacitor(yyvsp[-2].sval,yyvsp[-1].av_val);
            DBG1(printf("seen CAPACITOR: %s ",yyvsp[-2].sval);
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            free(yyvsp[-2].sval);
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 62:
{
            yyCircuit->add_diode(yyvsp[-2].sval,yyvsp[-1].av_val);
            DBG1(printf("seen DIODE: %s ",yyvsp[-2].sval);
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            free(yyvsp[-2].sval);
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 63:
{
            yyCircuit->add_inductor(yyvsp[-2].sval,yyvsp[-1].av_val);
            DBG1(printf("seen INDUCTOR: %s ",yyvsp[-2].sval);
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            free(yyvsp[-2].sval);
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 64:
{
            yyCircuit->add_coupling(yyvsp[-2].sval,yyvsp[-1].av_val);
            DBG1(printf("seen COUPLING: %s ",yyvsp[-2].sval);
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            free(yyvsp[-2].sval);
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 65:
{
            yyCircuit->add_isource(yyvsp[-2].sval,yyvsp[-1].av_val);
            DBG1(printf("seen ISOURCE: %s ",yyvsp[-2].sval);
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            free(yyvsp[-2].sval);
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 66:
{
            yyCircuit->add_jfet(yyvsp[-2].sval,yyvsp[-1].av_val);
            DBG1(printf("seen JFET: %s ",yyvsp[-2].sval);
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            free(yyvsp[-2].sval);
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 67:
{
            yyCircuit->add_mosfet(yyvsp[-2].sval,yyvsp[-1].av_val);
            DBG1(printf("seen MOSFET: %s ",yyvsp[-2].sval);
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)
            
            /* delete the arguments */
            free(yyvsp[-2].sval);
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 68:
{
            yyCircuit->add_resistor(yyvsp[-2].sval,yyvsp[-1].av_val);
            DBG1(printf("seen RESISTOR: %s ",yyvsp[-2].sval);
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            free(yyvsp[-2].sval);
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 69:
{
            yyCircuit->add_subcktinst(yyvsp[-2].sval,yyvsp[-1].av_val);
            DBG1(printf("seen SUBCKTINST: %s ",yyvsp[-2].sval);
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            free(yyvsp[-2].sval);
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 70:
{
            yyCircuit->add_vsource(yyvsp[-2].sval,yyvsp[-1].av_val);
            DBG1(printf("seen VSOURCE: %s ",yyvsp[-2].sval);
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            free(yyvsp[-2].sval);
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 71:
{
            yyCircuit->begin_subckt(yyvsp[-1].av_val);
            DBG1(printf("seen SUBCKT: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 72:
{
            /* unimplemented */
            DBG1(printf("seen .ALTER\n");)
        ;
    break;}
case 73:
{
            /* unimplemented */
            DBG1(printf("seen .CONTROL: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 74:
{
            /* unimplemented */
            DBG1(printf("seen .DATA: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 75:
{
            /* unimplemented */
            DBG1(printf("seen .DCVOLT: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 76:
{
            /* unimplemented */
            DBG1(printf("seen .DELLIB: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 77:
{
            /* unimplemented */
            DBG1(printf("seen .END: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 78:
{
            /* unimplemented */
            DBG1(printf("seen .END\n");)
        ;
    break;}
case 79:
{
            /* unimplemented */
            DBG1(printf("seen .ENDL: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 80:
{
            yyCircuit->end_subckt(yyvsp[-1].aval);
            DBG1(printf("seen .ENDS\n");)

            /* delete the arguments */
            delete yyvsp[-1].aval;
        ;
    break;}
case 81:
{
            /* unimplemented */
            DBG1(printf("seen .GLOBAL: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 82:
{
            /* unimplemented */
            DBG1(printf("seen .ICVOLT: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 83:
{
            /* unimplemented */
            DBG1(printf("seen .LIB: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 84:
{
            yyCircuit->add_model(yyvsp[-2].aval,yyvsp[-1].aval,NULL);
            DBG1(printf("seen .MODEL: ");
            yyvsp[-2].aval->dump(cout); cout<<" "; yyvsp[-1].aval->dump(cout); cout<<" ";);
            
            /* delete the arguments */
            delete yyvsp[-2].aval;
            delete yyvsp[-1].aval;
        ;
    break;}
case 85:
{
            yyCircuit->add_model(yyvsp[-3].aval,yyvsp[-2].aval,yyvsp[-1].av_val);
            DBG1(printf("seen .MODEL: ");
            yyvsp[-3].aval->dump(cout); cout<<" "; yyvsp[-2].aval->dump(cout); cout<<" ";
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            delete yyvsp[-3].aval;
            delete yyvsp[-2].aval;
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 86:
{
            yyCircuit->add_model(yyvsp[-5].aval,yyvsp[-4].aval,yyvsp[-2].av_val);
            DBG1(printf("seen .MODEL: ");
            yyvsp[-5].aval->dump(cout); cout<<" "; yyvsp[-4].aval->dump(cout); cout<<" ";
            cout<<"(";
            for_each(yyvsp[-2].av_val->begin(), yyvsp[-2].av_val->end(), G_dump<Argument *>(cout));
            cout<<")";
            cout<<endl;)
            
            /* delete the arguments */
            delete yyvsp[-5].aval;
            delete yyvsp[-4].aval;
            for(int i=0; i<yyvsp[-2].av_val->size(); i++)
                delete (*yyvsp[-2].av_val)[i];
            delete yyvsp[-2].av_val;
        ;
    break;}
case 87:
{
            /* unimplemented */
            DBG1(printf("seen .NODESET: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 88:
{
            /* unimplemented */
            DBG1(printf("seen .OPTIONS: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 89:
{
            /* unimplemented */
            DBG1(printf("seen .PARAM: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 90:
{
            /* unimplemented */
            DBG1(printf("seen .PC: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 91:
{
            /* unimplemented */
            DBG1(printf("seen .PROTECT\n");)
        ;
    break;}
case 92:
{
            /* unimplemented */
            DBG1(printf("seen .SYSTEM: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 93:
{
            /* unimplemented */
            DBG1(printf("seen .UNPROTECT\n");)
        ;
    break;}
case 94:
{
            /* unimplemented */
            DBG1(printf("seen .WIDTH: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 95:
{
            /* unimplemented */
            DBG1(printf("seen .ACSWEEP: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 96:
{
            /* unimplemented */
            DBG1(printf("seen .DCSWEEP: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 97:
{
            /* unimplemented */
            DBG1(printf("seen .FOURIER: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 98:
{
            /* unimplemented */
            DBG1(printf("seen .NET: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 99:
{
            /* unimplemented */
            DBG1(printf("seen .DISTORTION: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 100:
{
            /* unimplemented */
            DBG1(printf("seen .NOISE: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 101:
{
            /* unimplemented */
            DBG1(printf("seen .OPPOINT: ");
            cout<<endl;)
        ;
    break;}
case 102:
{
            /* unimplemented */
            DBG1(printf("seen .OPPOINT: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 103:
{
            /* unimplemented */
            DBG1(printf("seen .POLEZERO: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 104:
{
            /* unimplemented */
            DBG1(printf("seen .SAMPLE: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 105:
{
            /* unimplemented */
            DBG1(printf("seen .SENSE: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 106:
{
            /* unimplemented */
            DBG1(printf("seen .TEMP: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 107:
{
            /* unimplemented */
            DBG1(printf("seen .TRANSFER: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 108:
{
            /* unimplemented */
            DBG1(printf("seen .TRAN: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 109:
{
            /* unimplemented */
            DBG1(printf("seen .MEASURE: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 110:
{
            /* unimplemented */
            DBG1(printf("seen .GRAPH: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 111:
{
            /* unimplemented */
            DBG1(printf("seen .plot: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 112:
{
            /* unimplemented */
            DBG1(printf("seen .PRINT: ");
            for_each(yyvsp[-1].av_val->begin(), yyvsp[-1].av_val->end(), G_dump<Argument *>(cout));
            cout<<endl;)

            /* delete the arguments */
            for(int i=0; i<yyvsp[-1].av_val->size(); i++)
                delete (*yyvsp[-1].av_val)[i];
            delete yyvsp[-1].av_val;
        ;
    break;}
case 113:
{
            /* title */
            yyCircuit->name() = strdup(yyvsp[0].sval);
            DBG1(cout<<"title: "<<yyvsp[0].sval<<endl;)

            /* delete the arguments */
            free(yyvsp[0].sval);
        ;
    break;}
case 114:
{
            /* comment */
            StringArgument *temp = new StringArgument(yyvsp[0].sval);
            yyCircuit->process_comment((StringArgument *)temp);
            DBG1(cout<<endl<<"comment: "; temp->dump(cout); cout<<endl<<endl;);

            /* delete the arguments */
            delete temp;
        ;
    break;}
case 115:
{
            /* argument_list #1 */
            ArgumentVec *the_list = new ArgumentVec;
            the_list->push_back(yyvsp[0].aval);
            yyval.av_val = the_list;
        ;
    break;}
case 116:
{
            /* argument_list #2 */
            yyvsp[-1].av_val->push_back(yyvsp[0].aval);
        ;
    break;}
case 117:
{
            /* simple_argument_list #1 */
            ArgumentVec *the_list = new ArgumentVec;
            the_list->push_back(yyvsp[0].aval);
            yyval.av_val = the_list;
        ;
    break;}
case 118:
{
            /* simple_argument_list #2 */
            yyvsp[-1].av_val->push_back(yyvsp[0].aval);
        ;
    break;}
case 119:
{
            /* simple_argument_list #3 */
            yyvsp[-2].av_val->push_back(yyvsp[0].aval);
        ;
    break;}
case 120:
{
            /* parameter_list #1 */
            ArgumentVec *the_list = new ArgumentVec;
            the_list->push_back(yyvsp[0].aval);
            yyval.av_val = the_list;
        ;
    break;}
case 121:
{
            /* parameter_list #2 */
            yyvsp[-1].av_val->push_back(yyvsp[0].aval);
        ;
    break;}
case 122:
{
            /* argument #1 */
            yyval.aval = yyvsp[0].aval;
        ;
    break;}
case 123:
{
            /* argument #2 */
            yyval.aval = yyvsp[0].aval;
        ;
    break;}
case 124:
{
            /* simple_arg #1 */
            yyval.aval = new StringArgument(yyvsp[0].sval);
        ;
    break;}
case 125:
{
            /* simple_arg #2 */
            double num = atof(yyvsp[-1].sval);
            num = adjust_number(num,yyvsp[0].sval);
            yyval.aval = new DoubleArgument(num);
            free (yyvsp[-1].sval);
            free (yyvsp[0].sval);
        ;
    break;}
case 126:
{
            /* simple_arg #3 */
            int num = atoi(yyvsp[0].sval);
            yyval.aval = new IntegerArgument(num);
            free (yyvsp[0].sval);
        ;
    break;}
case 127:
{
            /* simple_arg #4 */
            int num = atoi(yyvsp[-1].sval);
            yyval.aval = new IntegerArgument(num);
            free (yyvsp[-1].sval);
        ;
    break;}
case 128:
{
            /* simple_arg #5 */
            double num = atof(yyvsp[-1].sval);
            num = adjust_number(num,yyvsp[0].sval);
            yyval.aval = new DoubleArgument(num);
            free (yyvsp[-1].sval);
            free (yyvsp[0].sval);
        ;
    break;}
case 129:
{
            /* simple_arg #6 */
            double num = atof(yyvsp[0].sval);
            yyval.aval = new DoubleArgument(num);
            free (yyvsp[0].sval);
        ;
    break;}
case 130:
{ 
            /* simple_arg #7 */
            double num = atof(yyvsp[0].sval);
            yyval.aval = new DoubleArgument(num);
            free (yyvsp[0].sval);
        ;
    break;}
case 131:
{
            /* simple_arg #8 */
            yyval.aval = yyvsp[0].aval;
        ;
    break;}
case 132:
{
            /* complex_arg #1 */
            yyval.aval = yyvsp[0].aval;
        ;
    break;}
case 133:
{
            /* complex_arg #2 */
            yyval.aval = yyvsp[0].aval;
        ;
    break;}
case 134:
{
            /* complex_arg #3 */
            yyval.aval = yyvsp[0].aval;
        ;
    break;}
case 135:
{
            /* function */
            yyval.aval = new FunctionArgument(yyvsp[-3].sval,yyvsp[-1].av_val);
        ;
    break;}
case 136:
{
            /* parameter */
            yyval.aval = new ParameterArgument(yyvsp[-2].sval,yyvsp[0].av_val);
        ;
    break;}
case 137:
{
            /* node_assignment */
            yyval.aval = new NodeAssignmentArgument(yyvsp[-2].aval,yyvsp[0].av_val);
        ;
    break;}
case 138:
{
            /* quoted_string */
            yyval.aval = new StringArgument(yyvsp[-1].sval);
        ;
    break;}
case 139:
{
            /* param_list #1 */
            ArgumentVec *the_list = new ArgumentVec;
            the_list->push_back(yyvsp[0].aval);
            yyval.av_val = the_list;
        ;
    break;}
case 140:
{
            /* param_list #2 */
            yyvsp[-2].av_val->push_back(yyvsp[0].aval);
        ;
    break;}
case 141:
{yyval.aval = yyvsp[0].aval;;
    break;}
case 142:
{
            /* ends_arg #1 */
            yyval.aval = NULL;
            DBG1(printf("Ending current subckt definition\n");)
        ;
    break;}
case 143:
{
            /* ends_arg #2 */
            yyval.aval = new StringArgument(yyvsp[0].sval);
            DBG1(printf("Ending subckt %s definition\n",yyvsp[0].sval);)
        ;
    break;}
}



  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


//
// global functions for yacc and flex generated code
//

// takes a double number and multiplies it by an appropriate
// scaling factor specified by the "unit" sting
double adjust_number (double num, char *unit) {

    if (!strncmp("MEG",unit,3)) {
        num *= pow(10.0,6.0);
    }
    else if (!strncmp("MI",unit,2)) {
        num *= (25.40 * pow(10,6.0));
    }
    else {
        switch(unit[0]) {
            case 'F':
            case 'f':
                num *= pow(10.0,-15.0);
                break;
            case 'P':
            case 'p':
                num *= pow(10.0,-12.0);
                break;
            case 'N':
            case 'n':
                num *= pow(10.0,-9.0);
                break;
            case 'U':
            case 'u':
                num *= pow(10.0,-6.0);
                break;
            case 'M':
            case 'm':
                num *= pow(10.0,-3.0);
                break;
            case 'K':
            case 'k':
                num *= pow(10.0,3.0);
                break;
            case 'G':
            case 'g':
                num *= pow(10.0,9.0);
                break;
            default:
                break;
        }
    }
    return num;
}        

// override default error reporting
void yyerror(char *msg) {
    extern int lineno;   // from flex lexer
    extern char *yytext; // from flex lexer

    fprintf(stderr, "line #%d: %s at '%s'\n",lineno,msg,yytext);
}

// override default yyin file
int yywrap() {

    FILE *file = 0;

    if ((currentFile != 0) && (nFiles > 1) && (currentFile < nFiles))
        fclose(yyin);

    while (currentFile < nFiles){
        file = fopen((*fileList)[currentFile++], "r");
        if (file != NULL) {
            yyin = file;
            break;
        }
        sprintf(error_msg, "could not open %s\n",(*fileList)[currentFile-1]);
        Abort(error_msg);
    }
    return (file ? 0 : 1);
}

// class method that calls the yacc parser
int hspice_parser::parse (vector<char*> *files) {

    currentFile = 0;
    fileList = files;
    nFiles = fileList->size();

    yyCircuit = &_circuit;
    
    // debugging
    yy_flex_debug = 0;   // enables debugging in flex when called with -d  flag
    yydebug = 0;         // enables debugging in yacc when called with -t flag
           
    if (nFiles < 1)
        return 0;

    yywrap();
    while (!feof(yyin)) {
        yyparse();
    }
    return 1;
}
